/************************************************************
   Graphic Console Open
   $Id:$
 ************************************************************/
#include <stdlib.h>
#include <string.h>
#include "gconsole.h"

struct GCON_HANDLER_STRUCT* gcon_open(int px,int py, int w, int h)
{
int i ;
struct GCON_HANDLER_STRUCT *gcon_ptr ; 

 for( i=0 ; i<MAX_GCON_HANDLE_NUM ; i++ ){
   if( gcon_handle[i]==0 ){
     gcon_ptr=malloc( sizeof(struct GCON_HANDLER_STRUCT) ) ;
     if( gcon_ptr==NULL ) return NULL ;
     gcon_ptr->id    =i ;
     gcon_ptr->px    =px ;
     gcon_ptr->py    =py ;
     gcon_ptr->width =w ;
     gcon_ptr->height=h ;
     gcon_ptr->cur_px=0 ;
     gcon_ptr->cur_py=0 ;
     gcon_ptr->fg_col.r=DEFAULT_FG_COLOR_R ;
     gcon_ptr->fg_col.g=DEFAULT_FG_COLOR_G ;
     gcon_ptr->fg_col.b=DEFAULT_FG_COLOR_B ;
     gcon_ptr->bg_col.r=DEFAULT_BG_COLOR_R ;
     gcon_ptr->bg_col.g=DEFAULT_BG_COLOR_G ;
     gcon_ptr->bg_col.b=DEFAULT_BG_COLOR_B ;
     gcon_ptr->pix_map=malloc( sizeof(struct VRAM_PIX) *
				FONT_WIDTH * FONT_HEIGHT *
				w * h ) ;
     if( gcon_ptr->pix_map==NULL ){
       free(gcon_ptr) ;
       return NULL ;
     }else{
       return gcon_ptr ;
     }
   }
 }
 return NULL ;
}

