/************************************************************
   Graphic Console Print
   $Id:$
 ************************************************************/
#include <stdlib.h>
#include <string.h>
#include "gconsole.h"

int gcon_print( struct GCON_HANDLER_STRUCT *gcon_ptr, char *str )
{
int i ;
int x,y ;
struct VRAM_PIX *wpix ;
 
 for( i=0 ; ; i++ ){
   if( str[i]=='\0' ) break ;
   switch( str[i] )
     {
     case 0x0a :
       wpix=&gcon_ptr->pix_map[(gcon_ptr->cur_py*FONT_HEIGHT)*gcon_ptr->width*FONT_WIDTH + gcon_ptr->cur_px*FONT_WIDTH] ;
       for( y=0 ; y<FONT_HEIGHT ; y++ ){
	 for( x=0 ; x<(gcon_ptr->width-gcon_ptr->cur_px)*FONT_WIDTH ; x++ ){
	   wpix[y*gcon_ptr->width*FONT_WIDTH+x]=gcon_ptr->bg_col ;
	 }
       }
       gcon_ptr->cur_px=0 ;
       gcon_ptr->cur_py=(gcon_ptr->cur_py+1) % gcon_ptr->height ;
       break ;
     default :
       if( str[i]<0x20 || str[i]>0x7e ) break ;

       wpix=&gcon_ptr->pix_map[(gcon_ptr->cur_py*FONT_HEIGHT)*gcon_ptr->width*FONT_WIDTH + gcon_ptr->cur_px*FONT_WIDTH] ;
       for( y=0 ; y<FONT_HEIGHT ; y++ ){
	 for( x=0 ; x<FONT_WIDTH ; x++ ){
	   if( gcon_font8x16[(str[i]-0x20)*FONT_WIDTH*FONT_HEIGHT+y*FONT_WIDTH+x]==0 ){
	     wpix[y*gcon_ptr->width*FONT_WIDTH+x]=gcon_ptr->bg_col ;
	   }else{
	     wpix[y*gcon_ptr->width*FONT_WIDTH+x]=gcon_ptr->fg_col ;
	   }
	 }
       }
       gcon_ptr->cur_px++ ;
       if( gcon_ptr->cur_px==gcon_ptr->width ){
	 gcon_ptr->cur_px=0 ;
	 gcon_ptr->cur_py=(gcon_ptr->cur_py+1) % gcon_ptr->height ;
       }
     }
 }
 gcon_draw( gcon_ptr ) ;
 return i ;
}
